#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sched.h>


int main(int argc, char *argv[])
{
  pid_t pid;
  int prio, policy;
  struct sched_param schp;

  if(argc!=4)
    {
      fprintf(stderr,"Usage: %s <pid> <policy> <rt-priority>\n",argv[0]);
      exit(1);
    }

  pid = atoi(argv[1]);

  if(!strcmp(argv[2],"normal"))
    {
      policy = SCHED_OTHER;
    }
  else if(!strcmp(argv[2],"rr"))
    {
      policy = SCHED_RR;
    }
  else if(!strcmp(argv[2],"fifo"))
    {
      policy = SCHED_FIFO;
    }
  else
    {
      fprintf(stderr,"Policies: normal, rr or fifo\n");
      exit(1);
    }
  prio = atoi(argv[3]);
  schp.sched_priority = prio;
  if(sched_setscheduler(pid, policy, &schp))
    {
      perror("sched_setscheduler:");
      exit(1);
    }

  return 0;
}
